function init()
    fly = {}
    fly.body = FindBody("body")
    fly.mass = GetBodyMass(fly.body)
    fly.status = "roam"
    fly.timer = math.random(10,20)

    flyBuzz = LoadLoop("MOD/flyloop.ogg",0.2)
end

function VecDist(a, b)
	return VecLength(VecSub(a, b))
end

function flyUpdate()
    fly.transform = GetBodyTransform(fly.body)
    fly.pos = fly.transform.pos
    fly.rot = fly.transform.rot
    fly.vel = GetBodyVelocity(fly.body)
    fly.fwd = TransformToParentVec(fly.transform,Vec(0,0,-1))
    fly.down = TransformToParentVec(fly.transform,Vec(0,-1,0))
    local com = GetBodyCenterOfMass(fly.body)
    fly.center = TransformToParentPoint(fly.transform,com)
    fly.angular = GetBodyAngularVelocity(fly.body)

    local frogs = FindBodies("frog",true)
    local distance = 0
    for i=1, #frogs do
        if i == 1 then 
            distance = VecDist(GetBodyTransform(frogs[i]).pos,fly.pos)
            fly.closestFrog = frogs[i]
        else
            if distance > VecDist(GetBodyTransform(frogs[i]).pos,fly.pos) then 
                fly.closestFrog = frogs[i]
            end
        end
    end

    if fly.closestFrog ~= 0 then 
        fly.target = VecAdd(Vec(math.random(-30,30),2,math.random(-30,30)), GetBodyTransform(fly.closestFrog).pos)
    end
end

function flyingUpdate(dt)
    PlayLoop(flyBuzz,fly.pos,1)
    QueryRejectBody(fly.body)
    local hit, dist, normal = QueryRaycast(fly.pos,Vec(0,-1,0),5,0.5)
    if hit or IsPointInWater(VecAdd(fly.pos,VecScale(Vec(0,-1,0),dist))) then 
        SetBodyVelocity(fly.body,VecScale(fly.vel,0.96))
        SetBodyAngularVelocity(fly.body,VecScale(fly.angular,0.98))
        ApplyBodyImpulse(fly.body,fly.center, Vec(0,math.clamp(fly.mass*(14-dist)*dt,0,15),0))
    end

    QueryRejectBody(fly.body)
    local hit, dist, normal = QueryRaycast(fly.pos,TransformToParentVec(fly.transform,Vec(0,0,-1)),2,0.5)
    if hit then 
        ApplyBodyImpulse(fly.body,fly.center,TransformToParentVec(fly.transform,Vec(0,0,10)))
    end


    ConstrainOrientation(fly.body,0,fly.rot,QuatLookAt(fly.pos,VecAdd(VecAdd(fly.pos,fly.vel)),1,1))


    if VecDist(fly.target,fly.pos) < 5 then 
        fly.target = VecAdd(Vec(math.random(-500,500),2,math.random(-500,500)), GetBodyTransform(fly.closestFrog).pos)
    end

    ApplyBodyImpulse(fly.body,fly.center,Vec(math.random(-10,10),math.random(-10,10),math.random(-10,10)))
    ApplyBodyImpulse(fly.body,fly.center,VecScale(VecNormalize(VecSub(fly.target,fly.pos)),0.4))


    if fly.pos[2] < -50 then 
        SetBodyTransform(fly.body,Transform(Vec(0,100,0)))
        SetBodyVelocity(fly.body,Vec(0,0,0))
    end
end

function update(dt)

    if fly.status ~= "dead" then
        if FindBody('body') == 0 then
            fly.status = "dead"
            RemoveTag(fly.body,"fly")
        end

        flyUpdate(dt)
        QueryRejectBody(fly.body)

        if fly.status == "roam" then
            flyingUpdate(dt)
        end

        if fly.timer > 0 then
            fly.timer = fly.timer - dt
        else
            if fly.status == "roam" then
                fly.status = "wait"
                fly.timer = math.random(5,15)
            elseif fly.status == "wait" then
                fly.status = "roam"
                fly.timer = math.random(4,20)
            end
        end

        if IsPointInWater(fly.pos) then 
            fly.status = "roam"
            fly.timer = math.random(16,20)
        end

        if VecDist(GetPlayerTransform().pos,fly.pos) < 3 and VecLength(GetPlayerVelocity()) > 3.5 then 
            fly.status = "roam"
            fly.timer = math.random(4,10)
        end

        if IsBodyBroken(fly.body) then 
            RemoveTag(fly.body,"fly")
        end
    end
end


function math.clamp(val, lower, upper)
    if lower > upper then lower, upper = upper, lower end -- swap if boundaries supplied the wrong way
    return math.max(lower, math.min(upper, val))
end
   --    local point = GetPlayerTransform().pos

   --    local target = VecNormalize(Vec(point[1],0,point[3]))
   --    local pos = VecNormalize(Vec(fly.pos[1],0,fly.pos[3]))
   --    local targetDir = VecNormalize(VecSub(target,pos))

   --    local up = TransformToParentVec(fly.transform,Vec(0,1,0))
   --    local cross = VecCross(targetDir,up)
   --    xAngle = VecDot(fly.fwd,cross)
   --    yAngle = VecDot(fly.fwd,targetDir)

   --    local offset = math.atan2(xAngle,yAngle)
   --    local ang = GetBodyAngularVelocity(fly.body)

   --    DebugPrint(offset)
   --    --SetBodyAngularVelocity(animal.body,VecLerp(ang,VecScale(Vec(0,-1,0),offset*dt),0.4))
